=== debian/changelog ===
grafx2 (2.3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS: fileformats.c:30:17: fatal error: png.h: No such file or
    directory": add build dependency on libpng-dev.
    (Closes: #669433)

 -- gregor herrmann <gregoa@debian.org>  Fri, 15 Jun 2012 15:34:23 +0200

grafx2 (2.3-1) unstable; urgency=low

  * New upstream version.
  * Bump standards version to 3.9.2.
  * Drop patch to fix strings, applied upstream.
  * Bump debhelper version to 8.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Thu, 14 Apr 2011 13:38:19 +0200
