## grafx2 2.4%2Bgit20180105

=== debian/watch ===
version=3
opts="uversionmangle=s/\.\d+$//" \
http://pulkomandy.tk/projects/GrafX2/downloads http://pulkomandy.tk/projects/GrafX2/downloads/grafx2-([\d\.]+)-src\.tgz
