## grafx2 2.4+git20180105

=== Makefile ===
all:
	$(MAKE) -C src/
