=== debian/changelog ===
grafx2 (2.4+git20180105-2) unstable; urgency=medium

  * misc/unix/grafx2.desktop: updated.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 04 Sep 2018 16:17:36 +0200

grafx2 (2.4+git20180105-1) unstable; urgency=medium

  * New upstream version. (Closes: #702657)
  * Upstream fix for "Parameter missing...". (Closes: #748333)
  * Acknowledge NMU. Thanks to gregor herrmann. (Closes: #669433)
  * Bump standards version to 4.1.3.
  * Bump debhelper version to 11.
  * Change my name.
  * Drop debian/menu.
  * debian/rules: modernized.
  * debian/watch: update URL.
  * debian/control: add missing b-d libfontconfig1-dev.
  * debian/copyright: update URL and years.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 05 Jan 2018 13:10:25 +0100
