=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: grafx2
 Section: x11
 Priority: optional
-Maintainer: Gürkan Sengün <gurkan@phys.ethz.ch>
-Build-Depends: debhelper (>= 8), libsdl1.2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, liblua5.1-0-dev, libpng-dev, pkg-config
-Standards-Version: 3.9.2
-Homepage: http://code.google.com/p/grafx2/
+Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
+Build-Depends: debhelper (>= 11), libsdl1.2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, liblua5.1-0-dev, libpng-dev, pkg-config, libfontconfig1-dev
+Standards-Version: 4.1.3
+Homepage: http://pulkomandy.tk/projects/GrafX2
 
 Package: grafx2
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-tuffy
 Description: ultimate 256-color bitmap paint program
  This is a bitmap paint program that allows you to draw in more than 60 video
  resolutions (from 320x200 to 1024x768, including most of the standard Amiga
